



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#中IDisposable学习</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#中IDisposable学习</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 15:13:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在Net中，由GC垃圾回收线程掌握对象资源的释放，程序员无法掌控析构函数的调用时机。对于一些非托管资源，比如数据库链接对象等，需要实现IDisposable接口进行手动的垃圾回收。那么什么时候使用Idisposable接口，以及如何使用呢？</p>
<p><strong>一、IDisposable的接口定义如下</strong></p>
<p>public interface IDisposable<br />{<br />&nbsp;&nbsp;&nbsp; // Summary:<br />&nbsp;&nbsp;&nbsp; //&nbsp;&nbsp;&nbsp;&nbsp; Performs application-defined tasks associated with freeing, releasing, or<br />&nbsp;&nbsp;&nbsp; //&nbsp;&nbsp;&nbsp;&nbsp; resetting unmanaged resources.<br />&nbsp;&nbsp;&nbsp; void Dispose();<br />}</p>
<p><strong>二：IDisposable基本应用</strong></p>
<p><strong>1.定义一个实现了IDisposable接口的类</strong></p>
<div>
<div>&nbsp;</div>
<div>
<div>C# 代码 &nbsp;&nbsp;复制</div>
<div>
<pre class="prettyprint linenums"><img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" /><br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" />public class CaryClass :IDisposable<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedBlockStart.gif" /> {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    public void DoSomething()<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />    {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />       Console.WriteLine("Do some thing....");<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />    }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    public void Dispose()<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />    {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />       Console.WriteLine("及时释放资源");<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />    }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedBlockEnd.gif" /> }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" /></pre>
</div>
</div>
</div>
<p><strong>2、两种方式来调用</strong></p>
<p><strong>（1）、使用Using语句会自动调用Dispose方法</strong></p>
<p>using (CaryClass caryClass = new CaryClass())</p>
<p>{</p>
<p>caryClass.DoSomething();</p>
<p>}</p>
<p><strong>（2）、现实调用该接口的Dispose方法</strong></p>
<pre class="prettyprint linenums">CaryClass caryClass = new CaryClass();<br />
try<br />
{<br />
     caryClass.DoSomething();<br />
}<br />
finally<br />
{<br />
     IDisposable disposable = caryClass as IDisposable;<br />
     if (disposable != null)<br />
         disposable.Dispose();<br />
}</pre>
<p><strong>三、IDisposable使用实例</strong></p>
<div>
<div>&nbsp;</div>
<div>
<div>
<div>
<div>C# 代码 &nbsp;&nbsp;复制</div>
<div>
<pre class="prettyprint linenums"><img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" /><br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" />public class DisposablClass : IDisposable<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedBlockStart.gif" />{<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    //是否回收完毕<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    bool _disposed;<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    public void Dispose()<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />    {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        Dispose(true);<br />
         GC.SuppressFinalize(this);<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />    }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    ~DisposableClass()<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />    {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        Dispose(false);<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />    }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    //这里的参数表示示是否需要释放那些实现IDisposable接口的托管对象<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    protected virtual void Dispose(bool disposing)<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />    {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        if(_disposed) return; //如果已经被回收，就中断执行<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        if(disposing)<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />        {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />            //TODO:释放那些实现IDisposable接口的托管对象<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />        }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        //TODO:释放非托管资源，设置对象为null<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        _disposed = true;<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />    }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedBlockEnd.gif" />}</pre>
</div>
</div>
</div>
</div>
</div>
<p><strong>四、IDisposable实例分析</strong></p>
<p><strong>Dispose()方法</strong></p>
<p>当需要回收非托管资源的DisposableClass类，就调用Dispoase()方法。而这个方法不会被CLR自动调用，需要手动调用。</p>
<p><strong>~DisposableClass()，析构函数</strong></p>
<p>当托管堆上的对象没有被其它对象引用，GC会在回收对象之前，调用对象的析构函数。这里的~DisposableClass()析构函数的意义在于告诉GC你可以回收我，Dispose(false)表示在GC回收的时候，就不需要手动回收了。</p>
<p><strong>虚方法Dispose(bool disposing)</strong></p>
<p>1、通过此方法，所有的托管和非托管资源都能被回收。参数disposing表示是否需要释放那些实现IDisposable接口的托管对象。</p>
<p>2、如果disposings设置为true，就表示DisposablClass类依赖某些实现了IDisposable接口的托管对象，可以通过这里的Dispose(bool disposing)方法调用这些托管对象的Dispose()方法进行回收。</p>
<p>3、如果disposings设置为false,就表示DisposableClass类依赖某些没有实现IDisposable的非托管资源，那就把这些非托管资源对象设置为null，等待GC调用DisposableClass类的析构函数，把这些非托管资源进行回收。</p>
<p>4、另外，以上把Dispose(bool disposing)方法设置为protected virtual的原因是希望有子类可以一起参与到垃圾回收逻辑的设计，而且还不会影响到基类。</p>
<p><strong>比如有这样的一个子类</strong></p>
<div>
<div>
<div>C# 代码 &nbsp;&nbsp;复制</div>
<div>
<pre class="prettyprint linenums"><img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" /><br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" />public class SubDisposableClass : DiposableClass<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedBlockStart.gif" />{<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    private bool _disposed; //表示是否已经被回收<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" /><br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />    protected override void Dispose(bool disposing)<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />    {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        if(!_disposed) //如果还没有被回收<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />        {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />            if(disposiing) //如果需要回收一些托管资源<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockStart.gif" />            {<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />               //TODO:回收托管资源，调用IDisposable的Dispose()方法就可以<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />            }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />            //TODO：回收非托管资源，把之设置为null，等待CLR调用析构函数的时候回收<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />            _disposed = true;<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" /><br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />        }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" />        base.Dispose(disposing);//再调用父类的垃圾回收逻辑<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedSubBlockEnd.gif" />    }<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/InBlock.gif" /><br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/ExpandedBlockEnd.gif" />}<br />
<img referrerpolicy="no-referrer"src="http://www.studyofnet.com/Codefan-Controls/OutliningIndicators/None.gif" /></pre>
</div>
</div>
</div>
<p><strong>五、IDisposable总结</strong></p>
<p>当我们自定义的类及其业务逻辑中引用某些托管和非托管资源，就需要实现IDisposable接口，实现对这些资源对象的垃圾回收。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8oj2y5q.html">Linux 使用Crontab设置定时调用Shell文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd57v79.html">linux 内核cache</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xwnkr9.html">UDP 单播、广播和多播</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zwxe59.html">ACM2034</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v06kn8.html">linux源码Makefile的详细分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1dp6d9.html">Asp&period;net MVC5中Html&period;DropDownList的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geoj4e8.html">题解 P3246 【&lbrack;HNOI2016&rsqb;序列】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllo6w0q.html">css基本语法及页面引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy35dx9.html">python中使用configparser库，实现配置文件的读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w6xxrq.html">git  简单命令总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7owp2e8.html">python访问百度地图接口并返回信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3rl6q.html">zynq基础--&amp;gt&semi;linux下软件应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rngzpdq.html">Codeforces Round &num;396 &lpar;Div&period; 2&rpar; C&period; Mahmoud and a Message dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvej6ox9.html">记一次爬虫经历&lpar;友话APP的Web端&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4w35pq.html">iOS支付宝支付集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d7ok38.html">request&period;getPathInfo&lpar;&rpar; 方法的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlompx6q.html">kong k8s 安装 以及可视化管理界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zvnl019.html">Servlet学习笔记06&mdash;&mdash;什么是转发，路径，状态管理？</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pojevq.html">bzoj3531【SDOI2014】旅行</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xp42w9.html">数据返回正常 而header头Status&equals;500</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1d6vj9.html">Visual Stuido 2015 Community 使用 GitHub 插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydo3vdq.html">Head First 设计模式系列之二----备忘录模式（java版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdwrg78.html">Linux Vi的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zd6w09.html">纯javascript 回到 顶部 实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zd6g49.html">Ajax请求过程中显示&OpenCurlyDoubleQuote;进度&rdquo;的简单实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn436j8.html">纯原生js移动端图片压缩上传插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1de459.html">css3太极图效果&plus;自动旋转</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok2ev59.html">Dede 列表页 缩略图 有显示无则不显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1xzoj9.html">&lbrack;转&rsqb;MonkeyRunner在Windows下的Eclipse开发环境搭建步骤&lpar;兼解决网上Jython配置出错的问题&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1dxxr9.html">poj 2135 Farm Tour 最小费用最大流建图跑最短路</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
